//
// Inicia la parte grafica en Xwindows
//
//
#include "pizarra.h"
#define MAX_COL 65535

unsigned long  * * dibujo ;
Colores listaColores[] = {
  Colores( "Negro",         0,         0,         0) , 
  Colores("Blanco", MAX_COL, MAX_COL, MAX_COL) , 
  Colores(   "Rojo",  MAX_COL,         0,         0) , 
  Colores( "Verde",          0, MAX_COL,         0) , 
  Colores(   "Azul",          0,          0, MAX_COL) ,
  Colores("Amarillo", MAX_COL, MAX_COL, 0),
  Colores("Naranja", MAX_COL, 35840, 0),
  Colores("Purpura", 40960, 8192, 61440),
  Colores("Cafe", MAX_COL, MAX_COL, 0)
};
const int numCol=sizeof(listaColores)/sizeof(listaColores[0]);

Display *mydisplay ;
int myscreen ;
Window mywindow;
GC mygc ;
Colormap cmap;
unsigned int width; 
unsigned int height;

int xiP;
int yiP;
int xfP;
int yfP;
int anchoxP ;
int anchoyP ;
double xiR;
double yiR;
double xfR;
double yfR;
double anchoxR ;
double anchoyR ;
 
int colorXnombre(String nombre)
{
  int indice = 0 ;
  for (int i = 0; i < numCol; i++) {
    if( nombre == listaColores[i].QNombre() ) indice = i; 
  }
  return indice ;
}

void initCol()
{
  XColor mycolor ;
  for (int i=0; i < numCol; i++) {
    mycolor.red = listaColores[i].CuanRojo() ;
    mycolor.green= listaColores[i].CuanVerde() ;
    mycolor.blue= listaColores[i].CuanAzul() ;
    XAllocColor(mydisplay, cmap, &mycolor) ;
    listaColores[i].PonePixel(mycolor.pixel ) ;
  }
}

void initX (String nombre, int xTotalSize, int yTotalSize)
{
  width  = xTotalSize ;
  height = yTotalSize ;
  anchoxP=xTotalSize ;
  anchoyP=yTotalSize ;


  int posInitX= 5;
  int posInitY=500;

  unsigned int border_width  = 5 ;
  
  mydisplay=XOpenDisplay("") ;

  if(mydisplay ==NULL)
    {
      cout <<"*** can't connect to server"<< endl ;
      exit(0) ;
    }

  myscreen=DefaultScreen(mydisplay) ;

  unsigned long border = BlackPixel(mydisplay, myscreen) ;
  unsigned long background = WhitePixel(mydisplay, myscreen) ;
  
  mywindow = XCreateSimpleWindow( mydisplay,
				  DefaultRootWindow(mydisplay), 
				  posInitX, posInitY, width, height,
				  border_width, border, background) ;

  XSetWindowAttributes setwinattr ;
  unsigned long valuemask;
  valuemask =CWBackingStore ;
  setwinattr.backing_store=Always ;  
  XChangeWindowAttributes(mydisplay, mywindow, valuemask, &setwinattr);
   
   
  XStoreName(mydisplay, mywindow, nombre) ;
  XSetIconName(mydisplay, mywindow, nombre) ;

  mygc = XCreateGC(mydisplay, mywindow, 0 ,0) ;

  long event_mask= ExposureMask | ButtonPressMask;
  XSelectInput(mydisplay, mywindow, event_mask) ;   

  XMapRaised(mydisplay, mywindow) ;
  XFlush(mydisplay) ;

  cmap = DefaultColormap( mydisplay,  myscreen );  

  initCol() ;
}



void coordenadas(double xi, double xf, double yi, double yf)
{
    xiP = 0;
    yiP = 0;
    xfP= anchoxP;
    yfP = anchoyP;
    if (xf >xi) {
      xiR = xi ;
      xfR = xf ;
    } else {
      cout << " Error en intervalo intervalo xf <= xi"<< endl; 
      exit(0);
    }
    if (yf >yi) {
      yiR = yi ;
      yfR = yf ;
    } else {
      cout << " Error en intervalo intervalo yf <= yi"<< endl; 
      exit(0);
    }
    anchoxR = fabs(xfR-xiR);
    anchoyR = fabs(yfR-yiR);
 }

void setRpointX(double x ,double y, String nombre)
{
  double rX=x ;
  double rY=y;
  if(x<xiR) rX=xiR ;
  if(x>xfR) rX=xfR ;
  if(y<yiR) rY=yiR ;
  if(y>yfR) rY=yfR ;
  setpointX(xfP-int((xfR-rX)*double(anchoxP) /anchoxR),
	    int((yfR-rY)*double(anchoyP)/anchoyR),
	    nombre );
}

void setpointX(int x, int y , String nombre)
{
  int red = listaColores[colorXnombre(nombre)].CuanRojo() ;
  int green = listaColores[colorXnombre(nombre)].CuanVerde() ;
  int blue = listaColores[colorXnombre(nombre)].CuanAzul() ;
  setpointX( x, y, red, green, blue );
}

void setRpointX(double x ,double y, int r, int g, int b)
{
  double rX=x ;
  double rY=y;
  if(x<xiR) rX=xiR ;
  if(x>xfR) rX=xfR ;
  if(y<yiR) rY=yiR ;
  if(y>yfR) rY=yfR ;
  setpointX(xfP-int((xfR-rX)*double(anchoxP) /anchoxR),
	    int((yfR-rY)*double(anchoyP)/anchoyR),
	    r, g, b);
}

void setpointX(int x ,int y , int r, int g, int b)
{
  if( (x<xiP) || (x>=xfP) || (y<yiP) || (y>=yfP) )  return ;
  XColor mycolor ;
  mycolor.red = (abs(r)>65535)? 65535: abs(r) ;
  mycolor.green= (abs(g)>65535)? 65535: abs(g) ;
  mycolor.blue= (abs(b)>65535)? 65535: abs(b) ;

  XAllocColor(mydisplay, cmap, &mycolor) ;

  XSetForeground(mydisplay, mygc, mycolor.pixel );
  XDrawPoint(mydisplay, mywindow, mygc, x, y) ;
  XFlush(mydisplay) ;
}

void closeX()
{
  XFreeGC(mydisplay, mygc) ;
  XDestroyWindow(mydisplay, mywindow) ;
  XCloseDisplay(mydisplay) ;
}

void esperando()
{

  XSelectInput(mydisplay, mywindow,  ExposureMask | KeyPressMask );

  XEvent myevent ;
  int done = 0 ;
  while (done == 0) {
    XNextEvent(mydisplay, &myevent) ;
    switch(myevent.type) {
    case Expose:
      {
	 ;
      }
      break;
    case KeyPress:
      {

	closeX() ;
	done=1 ;
      }
    }
  }
}





